//===================================================================
// aISA59s.pas
//-------------------------------------------------------------------
// aISA-M59
// Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.
//
// Date Dec.1998
//
// ̃\[Xɂ̓bp[֐̎gpႪLqĂ܂
//===================================================================
unit Aisa59s;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
	Aisa59w;

const
	szTitle		= 'Sample';
	szAisa59 	= 'aISA-M59';

type
  TMainForm = class(TForm)
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
		Function 	Aisa59_InitAxis(wLogSlot:Word;wAxis:Word):Boolean;
		procedure ResultMessage(strbuf:String);
		procedure ErrorMessage(wLogSlot:Word);

	end;

var
  MainForm: TMainForm;

implementation

{$R *.DFM}
procedure TMainForm.FormCreate(Sender: TObject);
var
	strbuf:		String;
	wLogSlot:	Word;
	wAxis:		Word;
	dwDllVer:	DWord;
	dwDrvVer:	DWord;
	ri:				TAISA59RESOURCE;
	b:				Byte;
	dwCount:	DWord;
begin
	//-----------------------------------------------------------------
	// Aisa59.dll J
	//-----------------------------------------------------------------
	if Aisa59wDllOpen() = False then begin
		ErrorMessage( AISA59_SLOT_AUTO );
		Halt;
	end;
	//-----------------------------------------------------------------
	// o[W\
	//-----------------------------------------------------------------
	if Aisa59wGetVersion(dwDllVer,dwDrvVer) = False then begin
		ErrorMessage( AISA59_SLOT_AUTO );
		Halt;
	end;
	strbuf:= Format(
						'GetVersion'#10+
						'Dll Version:%08xH'#10+
						'Drv Version:%08xH', [dwDllVer,dwDrvVer]);
	ResultMessage(strbuf);
	//-----------------------------------------------------------------
  // foCX̎gp錾
	//-----------------------------------------------------------------
	wLogSlot:=AISA59_SLOT_AUTO; // 󂫃foCXw
	if Aisa59wCreate( wLogSlot ) = False then begin
		ErrorMessage( AISA59_SLOT_AUTO );
		Halt;
	end;
	strbuf:=Format(
			'aISA-M59 Created'#10+
  		'LogSlot:%2d',[wLogSlot]);
	ResultMessage(strbuf);
	//-----------------------------------------------------------------
	// \[X\
	//-----------------------------------------------------------------
	if Aisa59wGetResource( wLogSlot, @ri ) = False then begin
		ErrorMessage( wLogSlot );
		Halt;
	end;
	strbuf:=Format(
			'aISA-M59 Resource'#10+
			'PortAdr:%04xH - %04xH',
			[ri.dwIOPortBase[1],ri.dwIOPortBase[1]+ri.dwIOPortLength[1]-1]);
	ResultMessage(strbuf);
	//-----------------------------------------------------------------
	// 䎲PɎw
	//-----------------------------------------------------------------
	wAxis := AISA59_AXIS_1;
	//-----------------------------------------------------------------
	// 䎲܂
	//-----------------------------------------------------------------
	if Aisa59_InitAxis( wLogSlot, wAxis ) = False then begin
		ErrorMessage( wLogSlot );
		Halt;
	end;
	strbuf:=
			'aISA-M59'#10+
			'䎲܂';
	ResultMessage(strbuf);
	//-----------------------------------------------------------------
	// { 1000pXo͋N܂
	//-----------------------------------------------------------------
	if Aisa59wDataFullWrite(
			wLogSlot, wAxis,
			AISA59_PLUS_PRESET_PULSE_DRIVE, 1000 ) = False then begin

		ErrorMessage( wLogSlot );
		Halt;
	end;
	strbuf:=
			'aISA-M59'#10+
			'{1000pXo͂Ă܂';
	ResultMessage(strbuf);
	//-----------------------------------------------------------------
	// hCuXe[^X擾
	//-----------------------------------------------------------------
	if Aisa59wGetDriveStatus( wLogSlot, wAxis, b ) = False then begin
		ErrorMessage( wLogSlot );
		Halt;
	end;
	//-----------------------------------------------------------------
	// rW[tOĂihCuȂj~
	//-----------------------------------------------------------------
	if ( b and $1 ) = $1 then begin
		if Aisa59wCommandWrite(
			wLogSlot, wAxis,  AISA59_SLOW_DOWN_STOP ) = False then begin
			ErrorMessage( wLogSlot );
			Halt;
		end;
		strbuf:=
				'aISA-M59'#10+
				'~܂';
		ResultMessage(strbuf);
	end;
	//-----------------------------------------------------------------
	// GhXe[^X擾
	//-----------------------------------------------------------------
	if Aisa59wGetEndStatus( wLogSlot, wAxis, b ) = False then begin
		ErrorMessage( wLogSlot );
		Halt;
	end;
	strbuf:=Format(
			'aISA-M59'#10+
			'GhXe[^X %02xh',[b]);
	ResultMessage(strbuf);
	//-----------------------------------------------------------------
	// JE^[̒l\
	//-----------------------------------------------------------------
	if Aisa59wDataFullRead(
 		wLogSlot, wAxis, AISA59_INTERNAL_COUNTER_READ, dwCount ) = False then begin
 		ErrorMessage( wLogSlot );
 		Halt;
 	end;
	//-----------------------------------------------------------------
	// g
	//-----------------------------------------------------------------
	if ( dwCount and $08000000 ) <> 0 then dwCount:=dwCount or $F0000000;

	strbuf:=Format(
			'aISA-M59'#10+
  		'JE^[:%d',[dwCount]);
	ResultMessage(strbuf);
	//-----------------------------------------------------------------
	// JjJVOi\
	//-----------------------------------------------------------------
	if Aisa59wGetMechanicalSignal( wLogSlot, wAxis, b ) = False then begin
		ErrorMessage( wLogSlot );
		Halt;
	end;
	strbuf:=Format(
			'aISA-M59'#10+
			'JjJVOi %02xh',[b]);
	ResultMessage(strbuf);
	//-----------------------------------------------------------------
	// jo[TVOi\
	//-----------------------------------------------------------------
	if Aisa59wGetUniversalSignal( wLogSlot, wAxis, b ) = False then begin
		ErrorMessage( wLogSlot );
		Halt;
	end;
	strbuf:=Format(
			'aISA-M59'#10+
			'jo[TVOi %02xh',[b]);
	ResultMessage(strbuf);
	//-----------------------------------------------------------------
	// foCX
	//-----------------------------------------------------------------
	if Aisa59wClose( wLogSlot ) = False then begin
		ErrorMessage( wLogSlot );
		Halt;
	end;
	strbuf:=Format(
			'aISA-M59 Close'#10+
  		'LogSlot:%2d',[wLogSlot]);
	ResultMessage(strbuf);
	Halt;
end;
//===================================================================
// I
//===================================================================
procedure TMainForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
	Aisa59wDllClose();
end;
//===================================================================
// 䎲̏
//-------------------------------------------------------------------
//   		wLogSlot	foCXԍ
//					wAxis			䎲
//                  	AISA59_AXIS_1 ` AISA59_AXIS_4 w肵܂
//===================================================================
Function TMainForm.Aisa59_InitAxis(wLogSlot:Word;wAxis:Word):Boolean;
begin
	Result:=False;
	//-----------------------------------------------------------------
	// MODE1 SET
	//
	// Jn|Cgo				
  // pXo͕									QpX
	// DIR   o͒[q 								CWpX  ANeBu Hi
	// PULSE o͒[q									CCWpX ANeBu Hi
	//-----------------------------------------------------------------
	if False = Aisa59wMode1Write( wLogSlot, wAxis, $40 ) then Exit;
	//-----------------------------------------------------------------
	// MODE2 SET
	//
	// EXTERNAL COUNTER ͎dl      QMS{
	// DEND ͐MANeBux	Low
	// DERR ͐MANeBux	Low
	// -SLM ͐MANeBux	Low
	// +SLM ͐MANeBux	Low
	// -ELM ͐MANeBux	Low
	// +ELM ͐MANeBux	Low
	//-----------------------------------------------------------------
	if False = Aisa59wMode2Write( wLogSlot, wAxis, $FF ) then Exit;
	//-----------------------------------------------------------------
	// [hݒ
	//
	// INPOSITION WAIT MODE RESET
	// ALARM STOP ENABLE MODE SET
	// INTERRUPT OUT ENABLE MODE RESET
	//-----------------------------------------------------------------
	if False = Aisa59wCommandWrite( wLogSlot, wAxis, AISA59_INPOSITION_WAIT_MODE_RESET ) then Exit;
	if False = Aisa59wCommandWrite( wLogSlot, wAxis, AISA59_ALARM_STOP_ENABLE_MODE_SET ) then Exit;
	if False = Aisa59wCommandWrite( wLogSlot, wAxis, AISA59_INTERRUPT_OUT_ENABLE_MODE_RESET ) then Exit;
	//-----------------------------------------------------------------
	// f[^ݒ
	//
	// RANGE DATA								50		o͎gݒP 	50050=10PPS
	// START/STOP SPEED DATA		100		Jn~g 			100~10PPS=1000PPS
	// OBJECT SPEED DATA				4000	ړIg 					4000~10PPS=40000PPS
	// RATE-1 DATA              1024  ԐݒP 		1024(2.048~10^6)=0.5mSec
	//																 						(4000-100)~0.5mSec = 1.95Sec
	// RATE-2 DATA        						ftHgl 8191(1FFFh)
	// RATE-3 DATA										ftHgl 8191(1FFFh)
	// RATE CHANGE POINT 1-2					ftHgl 8191(1FFFh)
	// RATE CHANGE POINT 2-3					ftHgl 8191(1FFFh)
	//
  // ̐ݒɂ RATE-1 DATA ɂ钼ƂȂ܂
	//-----------------------------------------------------------------
	if False = Aisa59wDataHalfWrite( wLogSlot, wAxis, AISA59_RANGE_WRITE, 50 ) then Exit;
	if False = Aisa59wDataHalfWrite( wLogSlot, wAxis, AISA59_START_STOP_SPEED_DATA_WRITE, 100 ) then Exit;
	if False = Aisa59wDataFullWrite( wLogSlot, wAxis, AISA59_OBJECT_SPEED_DATA_WRITE, 4000 ) then Exit;
	if False = Aisa59wDataFullWrite( wLogSlot, wAxis, AISA59_RATE1_DATA_WRITE, 1024 ) then Exit;
	//-----------------------------------------------------------------
	// AhXݒ
	//
  // INTERNAL COUNTER y EXTERNAL COUNTER  0h ݂܂
	//-----------------------------------------------------------------
	if False = Aisa59wDataFullWrite( wLogSlot, wAxis, AISA59_INTERNAL_COUNTER_WRITE, 0 ) then Exit;
	if False = Aisa59wDataFullWrite( wLogSlot, wAxis, AISA59_EXTERNAL_COUNTER_WRITE, 0 ) then Exit;
	Result:=True;
end;
//===================================================================
// ʂ\
//===================================================================
procedure TMainForm.ResultMessage(strbuf:String);
begin
	Application.MessageBox(PChar(strbuf), szTitle, MB_OK + MB_ICONINFORMATION);
end;
//===================================================================
// G[bZ[W\
//===================================================================
procedure TMainForm.ErrorMessage(wLogSlot:Word);
var
	dwRes:	DWord;
	strbuf:	String;
begin
	dwRes:=Aisa59wGetLastError(wLogSlot);
	if dwRes = AISA59_ERR_WRAPDLL then begin
		strbuf:='DLL Load error';
	end else begin
		strbuf:=Format(
							'aISA-M59 error'#10#10'Error code:%08xH',[dwRes]);
	end;
	Application.MessageBox(PChar(strbuf), szTitle, MB_OK + MB_ICONSTOP);
end;


end.
